package jdbc.example.dependant.bean;

import java.util.HashMap;
import java.util.Map;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;

import org.codehaus.jackson.annotate.JsonProperty;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import jdbc.example.hospilalisation.bean.Hospitalisations;

@XmlAccessorType(XmlAccessType.NONE)

@XmlRootElement(name = "Dependant")
public class Dependant {
	private static Logger log = LoggerFactory.getLogger(Dependant.class);
	@JsonProperty("hospitalisations")
	Hospitalisations hospitalisations;
	private String age;
	private Long employeeKey;
	private String dependantId;
	private Long dependantKey;
	private String dependantName;
	private String empId;
	private String relationWithEmp;
	private String tableName;

	@Override
	public String toString() {
		if (log.isDebugEnabled()) {
			StringBuilder builder = new StringBuilder();
			builder.append("\n age=" + age);
			builder.append("\n employeeKey=" + employeeKey);
			builder.append("\n dependantId=" + dependantId);
			builder.append("\n dependantKey=" + dependantKey);
			builder.append("\n dependantName=" + dependantName);
			builder.append("\n empId=" + empId);
			builder.append("\n relationWithEmp=" + relationWithEmp);
			builder.append("\n tableName=" + tableName);
			return builder.toString();
		} else {
			return "age=" + age;
		}
	}

	@XmlAttribute(name = "Age")
	public String getAge() {
		return age;
	}

	@XmlAttribute(name = "EmployeeKey")
	public Long getEmployeeKey() {
		return employeeKey;
	}

	@XmlAttribute(name = "DependantId")
	public String getDependantId() {
		return dependantId;
	}

	@XmlAttribute(name = "DependantKey")
	public Long getDependantKey() {
		return dependantKey;
	}

	@XmlAttribute(name = "DependantName")
	public String getDependantName() {
		return dependantName;
	}

	@XmlAttribute(name = "EmpId")
	public String getEmpId() {
		return empId;
	}

	@XmlAttribute(name = "RelationWithEmp")
	public String getRelationWithEmp() {
		return relationWithEmp;
	}

	@XmlAttribute(name = "TableName")
	public String getTableName() {
		return tableName;
	}

	@XmlElement(name = "Hospitalisations")
	public Hospitalisations getHospitalisations() {
		if (hospitalisations == null)
			hospitalisations = new Hospitalisations();
		return hospitalisations;
	}

	public static void setLog(Logger log) {
		Dependant.log = log;
	}

	public void setHospitalisations(Hospitalisations hospitalisations) {
		this.hospitalisations = hospitalisations;
	}

	public void setAge(String age) {
		this.age = age;
	}

	public void setEmployeeKey(Long employeeKey) {
		this.employeeKey = employeeKey;
	}

	public void setDependantId(String dependantId) {
		this.dependantId = dependantId;
	}

	public void setDependantKey(Long dependantKey) {
		this.dependantKey = dependantKey;
	}

	public void setDependantName(String dependantName) {
		this.dependantName = dependantName;
	}

	public void setEmpId(String empId) {
		this.empId = empId;
	}

	public void setRelationWithEmp(String relationWithEmp) {
		this.relationWithEmp = relationWithEmp;
	}

	public void setTableName(String tableName) {
		this.tableName = tableName;
	}

}
