package jdbc.example.hospilalisation.bean;

import java.sql.Date;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@XmlAccessorType(XmlAccessType.NONE)

@XmlRootElement(name = "Hospitalisation")
public class Hospitalisation {
	private static Logger log = LoggerFactory.getLogger(Hospitalisation.class);
	private Long hospitalisationKey;
	private String dependantId;
	private String empId;
	private Date admissionDate;
	private Date releaseDate;
	private String hospitalName;
	private String treatmentDtls;
	private Double hospitalBillAmt;
	private String defaultstr;

	@Override
	public String toString() {
		if (log.isDebugEnabled()) {
			StringBuilder builder = new StringBuilder();
			builder.append("\n hospitalisationKey=" + hospitalisationKey);
			builder.append("\n dependantId=" + dependantId);
			builder.append("\n empId=" + empId);
			builder.append("\n admissionDate=" + admissionDate);
			builder.append("\n releaseDate=" + releaseDate);
			builder.append("\n hospitalName=" + hospitalName);
			builder.append("\n treatmentDtls=" + treatmentDtls);
			builder.append("\n hospitalBillAmt=" + hospitalBillAmt);
			return builder.toString();
		} else {
			return "hospitalisationKey=" + hospitalisationKey;
		}
	}

	@XmlAttribute(name = "HospitalisationKey")
	public Long getHospitalisationKey() {
		return hospitalisationKey;
	}

	@XmlAttribute(name = "DependantId")
	public String getDependantId() {
		return dependantId;
	}

	@XmlAttribute(name = "EmpId")
	public String getEmpId() {
		return empId;
	}

	@XmlAttribute(name = "AdmissionDate")

	public Date getAdmissionDate() {
		return admissionDate;
	}

	@XmlAttribute(name = "ReleaseDate")

	public Date getReleaseDate() {
		return releaseDate;
	}

	@XmlAttribute(name = "HospitalName")
	public String getHospitalName() {
		return hospitalName;
	}

	@XmlAttribute(name = "TreatmentDtls")
	public String getTreatmentDtls() {
		return treatmentDtls;
	}

	@XmlAttribute(name = "HospitalBillAmt")
	public Double getHospitalBillAmt() {
		return hospitalBillAmt;
	}

	public static Logger getLog() {
		return log;
	}

	public static void setLog(Logger log) {
		Hospitalisation.log = log;
	}

	public void setHospitalisationKey(Long hospitalisationKey) {
		this.hospitalisationKey = hospitalisationKey;
	}

	public void setDependantId(String dependantId) {
		this.dependantId = dependantId;
	}

	public void setEmpId(String empId) {
		this.empId = empId;
	}

	public void setAdmissionDate(Date admissionDate) {
		this.admissionDate = admissionDate;
	}

	public void setReleaseDate(Date releaseDate) {
		this.releaseDate = releaseDate;
	}

	public void setHospitalName(String hospitalName) {
		this.hospitalName = hospitalName;
	}

	public void setTreatmentDtls(String treatmentDtls) {
		this.treatmentDtls = treatmentDtls;
	}

	public void setHospitalBillAmt(Double hospitalBillAmt) {
		this.hospitalBillAmt = hospitalBillAmt;
	}

}
