package jdbc.example.test;

import java.util.List;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import jdbc.example.dependant.bean.Dependant;
import jdbc.example.employee.bean.Employee;
import jdbc.example.employee.service.EmployeeService;
import jdbc.example.hospilalisation.bean.Hospitalisation;

public class TestJdbc {

	public static void main(String[] args) throws Exception {
		ApplicationContext context = new ClassPathXmlApplicationContext("file:spring-context.xml");

		Employee employee = new Employee();
		employee.setEmpId("" + System.currentTimeMillis());
		employee.setName("Sadhan");
		employee.setDateOfJoining(null);
		employee.setBasicSal(2000.0);

		EmployeeService empService = (EmployeeService) context.getBean("employeeService");

		List<Employee> listEmp = empService.getEmployeeList(employee);
		System.out.println("------Record count : " + listEmp.size());

		int count=1;
		for (Employee emp : listEmp) {

			String empId = emp.getEmpId();
			String empName = emp.getName();
			System.out.println("==============Record"+ count++ + "==================");
			System.out.print(emp.getEmployeeKey()+"|empId=" + empId + "| empName=" + empName+"\n");

			for (Dependant dependant : emp.getDependants().getDependantList()) {
				String dependantId = dependant.getDependantId();
				String dependantName = dependant.getDependantName();
				System.out.print("    dependantId=" + dependantId + "| dependantName=" + dependantName+"\n");

				for (Hospitalisation hosRecord : dependant.getHospitalisations().getHospitalisationList()) {
					String hosName = hosRecord.getHospitalName();

					String admissionDte = "" + hosRecord.getAdmissionDate();

					System.out.print("        hospitalName=" + hosName + "| admissionDte=" + admissionDte+"\n");
				}
			}
			System.out.println("");
		}

	}
}
